<?PHP

/**
 * FOSSFA database
 */

require_once( 'tiki-setup.php' ); 
require_once( 'lib/fossfalib.php' ); 

$flib = new FossfaLib( $dbTiki ); 
$ulib = new UsersLib( $dbTiki );

if( isset($_GET["edit"]) ){ $edit = $_GET["edit"]; } else { $edit = ""; }
if( isset($_GET["view"]) ){ $view = $_GET["view"]; } else { $view = ""; }
if( isset($_GET["id"]) ){ $id = $_GET["id"]; } else { $id = -1; }


if( isset($_REQUEST["find"]) ){
    
  $db = "project";
  if( isset($_REQUEST["search_db"]) ){ $db=$_REQUEST["search_db"]; }

  show_search( $_REQUEST["search"], $db );

} else if( $edit=="person" ){
  // edit the personal page

  if( isset($_REQUEST["username"]) ){
    $person = $flib->get_person( $_REQUEST["username"] );
  } else {
    $person = $flib->get_person( $user );
  }

  if( isset($_REQUEST["save"]) ){
    // save values ....
    
    if( !(($user==$_POST["username"]) || ($tiki_p_admin == 'y')) ){
	// no permission
	$smarty->assign('msg', tra("Permission denied to edit this project"));       
	$smarty->display("styles/$style_base/error.tpl");    
	die;
    }
    
    if( isset($_REQUEST["username"]) ){
      $username = $_REQUEST["username"];
    } else {
      $username = $user;
    }

    $flib->update_person( $username, $_POST );
    
    // check image
    if( isset($_FILES["new_image"]) && is_uploaded_file($_FILES['new_image']['tmp_name']) ){
      $fp = fopen($_FILES['new_image']['tmp_name'],"rb");
      $imgdata = fread($fp,filesize($_FILES['new_image']['tmp_name']));
      fclose($fp);
      $imgtype = $_FILES['new_image']['type'];
      $imgsize = $_FILES['new_image']['size'];
      $imgname = $_FILES['new_image']['name'];
      
      $flib->update_image( $username, $imgdata, $imgtype, $imgsize, $imgname );
    }
    
    show_person( $username );
  } else {
    // show edit form
    show_personedit( $person );
  }
  
} else if( $edit=="project" ){

  if( isset($_REQUEST["delete"]) && ($_REQUEST["delete"]==1) ){
    // DELETE

    $flib->delete_project($id);
    header( "Location: fossfa-db.php" );
    die;

  } else if( isset($_REQUEST["save"]) ){
    // save values ....

    if( $id>0 ){
      $project = $flib->get_project($id);
      if( !(($user == $project["owner"]) || ($tiki_p_admin == 'y')) ){
	// no permission
	$smarty->assign('msg', tra("Permission denied to edit this project"));       
	$smarty->display("styles/$style_base/error.tpl");    
	die;
      }
    }
    
    $id = $flib->update_project( $id, $_POST );
    print "project updated.<br />";
    show_project( $id );

  } else {
    show_projectedit( $id );
  }

} else if( $view=="person" ){

  if( !isset($_REQUEST["username"]) ){
    // no name specified
    print "ERROR: no person specified";
    show_index();
  } else {
    show_person( $_REQUEST["username"] );
  }

} else if( $view=="project" ){
  
  if( !$id>0 ){
    print "ERROR: no project specified";
    show_index();
  } else {
    show_project( $id );
  }

} else {
  // display the main database page
  show_index();
}



function show_index(){
  global $user, $smarty, $flib;

  $people = $flib->get_person_list(10);
  $projects = $flib->get_project_list(10);

  $smarty->assign_by_ref( 'people', $people );
  $smarty->assign_by_ref( 'projects', $projects );

  $smarty->assign('mid','fossfa-db.tpl'); 
  $smarty->display('tiki.tpl');
}


function show_person( $username ){
  global $user, $tikilib, $smarty, $flib, $tmpDir;
  
  $person = $flib->select_user( $username );
  
  if( !$person || ($person["publish"]!=1) ){
    // page not existing or not published
    print "ERROR: ".$_REQUEST["username"]. " has no personal page.";
    show_index();
  }

  // parse body content
  if( $person["format"]=="wiki" ){
    $body = $tikilib->parse_data( $person["body"] );
  } else if( $person["format"]=="html" ){
    $body = $person["body"];
  } else {
    $body = htmlspecialchars( stripslashes($person["body"]) );
    $body = ereg_replace( "\n", "<br>\n", $body );
  }
  
  // allow edit link
  if( ($user == $username) || ($GLOBALS["tiki_p_admin"] == "y") )
    $smarty->assign( 'allow_edit', 1 );
  
  //format dates
  $person["entered"] = date( "M d, Y", $person["entered"] );
  $person["modified"] = date( "M d, Y", $person["modified"] );

  $smarty->assign( 'body', $body );
  $smarty->assign_by_ref( 'person', $person );
  $smarty->assign('mid','fossfa-db_personview.tpl'); 
  $smarty->display('tiki.tpl'); 
  
} 


function show_personedit( $person ){
  global $user, $smarty, $flib;
  
  $body = stripslashes($person["body"]);

  $smarty->assign_by_ref( 'person', $person );
  $smarty->assign('body', $body );
  $smarty->assign('mid','fossfa-db_personedit.tpl'); 
  $smarty->display('tiki.tpl');
}



function show_project( $id ){
  global $user, $smarty, $tikilib, $flib;
  
  $project = $flib->get_project( $id );
  
  if( !$project ){
    // page not existing or not published
    print "ERROR: no such project page ($id).";
    show_index();
  }

  // parse body content
  if( $project["format"]=="wiki" ){
    $body = $tikilib->parse_data( stripslashes($project["body"]) );
  } else if( $project["format"]=="html" ){
    $body = $project["body"];
  } else {
    $body = htmlspecialchars( stripslashes($project["body"]) );
    $body = ereg_replace( "\n", "<br>\n", $body );
  }
  
  // allow edit link
  if( ($user == $project["owner"]) )
    $smarty->assign( 'allow_edit', 1 );

  $person = $flib->get_person( $project["owner"] );
  if( strlen($person["name"])>0 ){
    $owner = $person["name"];
  } else {
    $owner = $person["username"];
  }
  
  //format dates
  $project["entered"] = date( "M d, Y", $project["entered"] );
  $project["modified"] = date( "M d, Y", $project["modified"] );

  //check homepage
  if( !preg_match( "/^http\:\/\//", $project["homepage"] ) ){
    $project["homepage"] = "http://".$project["homepage"];
  }

  $smarty->assign( 'body', $body );
  $smarty->assign_by_ref( 'project', $project );
  $smarty->assign( 'owner', $owner );
  $smarty->assign_by_ref( 'person', $person );
  $smarty->assign('mid','fossfa-db_projectview.tpl'); 
  $smarty->display('tiki.tpl'); 
  
}


function show_projectedit( $id=-1 ){
  global $user, $flib, $smarty, $style_base;
  // edit a project page

  if( $id>0 ){
    $project = $flib->get_project( $id );
    $smarty->assign_by_ref( 'project', $project );
  
    $body = stripslashes($project["body"]);
    $smarty->assign( 'body', $body );
  }

  $smarty->assign('mid','fossfa-db_projectedit.tpl'); 
  $smarty->display('tiki.tpl');
}


function show_search( $term, $what="project" ){
  global $user, $flib, $smarty, $style_base;

  $smarty->assign( 'term', $term );
  $smarty->assign( 'search_db', $what );


  $result = $flib->search( $term, $what );
  $smarty->assign( 'nr', count($result) );
  $smarty->assign_by_ref( 'result', $result );
  
  $smarty->assign('mid','fossfa-db_search.tpl'); 
  $smarty->display('tiki.tpl');
}



?>
