<?PHP

/**
 *
 * fossfalib.php - libraray for the fossfa_db (projects & people)
 *-----------------------------------------------------------------
 * (c) 2003, KB
 * this is free software. you may use, copy, modify and distribute
 * this file according to the GPL license.
 *
 */


require_once( "userslib.php" );


class FossfaLib{
  var $db; // the ressource pointer to the tiki db
  var $person_name;
  var $person_email;
  var $person_description;
  var $person_publish;

  function FossfaLib( $db ){
    if( !$db ){ 
      die( "Invalid db object passed to FossfaLib constructor" ); 
    } 
    $this->db = $db; 
  }

  function sql_error($query, $result) { 
    trigger_error("MYSQL error: ".$result->getMessage()." in query:<br/>".$query."<br/>",E_USER_WARNING); 
    die; 
  }


  function update_project( $id, $data){
    global $user;
    // update user page
    
    $name      = addslashes($data["name"]);
    $sponsor   = addslashes($data["sponsor"]);
    $homepage  = $data["homepage"];
    $shortdesc = addslashes($data["shortdesc"]);
    $body      = addslashes($data["body"]);

    $now = date("U");

    if( $id>0 ){
      // check if project exists

      $q = "SELECT * FROM fossfa_project WHERE projectId='$id'";
      $result = $this->db->query( $q );
      if( DB::isError($result) ) 
	$this->sql_error( $q, $result );
      
      if( $result->numRows() < 1 ){
	print "ERROR: update_project() no such project";
	return false;
      }
    } else {
      // insert first and then get new id

      $q = "INSERT INTO fossfa_project (owner,entered,visible) VALUES ('$user','$now',1 )";
      $result = $this->db->query( $q );
      if( DB::isError($result) ) 
	$this->sql_error( $q, $result );
      
      $q = "SELECT * FROM fossfa_project WHERE owner='$user' AND entered='$now'";
      $result = $this->db->query( $q );
      if( DB::isError($result) ) 
	$this->sql_error( $q, $result );
      $res = $result->fetchRow(DB_FETCHMODE_ASSOC);
      $id = $res["projectId"];
    }
    
    $q = "UPDATE fossfa_project SET ".
      " name='$name', sponsor='$sponsor', shortdesc='$shortdesc', ".
      " homepage='$homepage', body='$body', format='".$data["format"]."', ".
      " modified='$now' WHERE projectId='$id'";
    $result = $this->db->query( $q ); 
    if( DB::isError($result) ) 
      $this->sql_error( $q, $result );

    // finally return project id.
    return $id;
  }

  function get_project( $id ){
    $q = "SELECT * FROM fossfa_project WHERE projectId='$id'";
    $result = $this->db->query( $q  );
    if( DB::isError($result) ) 
      $this->sql_error( $q, $result );
    
    return $result->fetchRow(DB_FETCHMODE_ASSOC);
  }

  function get_project_list( $n=10 ){
    $q = "SELECT * FROM fossfa_project WHERE visible=1 ".
      " ORDER by modified DESC LIMIT $n";
    $result = $this->db->query( $q ); 
    if( DB::isError($result) ) 
      $this->sql_error( $q, $result );
    $ret = Array();
    while( $res = $result->fetchRow(DB_FETCHMODE_ASSOC) ){ 
      $ret[] = $res; 
    } 
    return $ret;
  }
  
   
  function delete_project( $id ){
    
    $now = date("U");

    if( $id>0 ){
      // check if project exists

      $q = "SELECT * FROM fossfa_project WHERE projectId='$id'";
      $result = $this->db->query( $q );
      if( DB::isError($result) ) 
	$this->sql_error( $q, $result );
      
      if( $result->numRows() < 1 ){
	print "ERROR: update_project() no such project";
	return false;
      }
    
      $q = "UPDATE fossfa_project SET visible=0,modified='$now' ".
	" WHERE projectId='$id'";
      $result = $this->db->query( $q );
      if( DB::isError($result) ) 
	$this->sql_error( $q, $result );      
    } 
  }



  /**
   * API for the person database
   */ 


  function get_person( $username ){     
    $result = $this->db->query( "SELECT * FROM fossfa_people WHERE username='$username'" );
    if( DB::isError($result) ) 
      $this->sql_error( $query, $result );
    
    return $result->fetchRow(DB_FETCHMODE_ASSOC);
  } 

  function select_user( $username ){ 
    return $this->get_person( $username );
  }


  function update_user( $username, $data ){
    $this->update_person( $username, $data );
  }

  function update_person( $username, $data ){
    // update user page
    
    $name      = addslashes($data["name"]);
    $email     = addslashes($data["email"]);
    $based     = addslashes($data["based"]);
    $interests = addslashes($data["interests"]);
    $body      = addslashes($data["body"]);
    if( isset($data["publish"]) ){ $publish = 1; } else { $publish = 0; }
    if( isset($data["show_email"]) ){ $show_email = 1; } else { $show_email = 0; }

    $now = date("U");

    $result = $this->db->query( "SELECT * FROM fossfa_people WHERE username='$username'" );
    if( DB::isError($result) ) 
      $this->sql_error( $q, $result );
    
    if( $result->numRows() < 1 ){
      $q = "INSERT INTO fossfa_people (username) VALUES ('$username')";
      $result = $this->db->query( $q );  
      if( DB::isError($result) ) 
	$this->sql_error( $q, $result );
    } 
    
    $q = "UPDATE fossfa_people SET ".
      " name='$name', email='$email', based='$based', ".
      " interests='$interests', body='$body', format='".$data["format"]."', ".
      " homepage='".$data["homepage"]."', show_email='$show_email', publish='$publish', ".
      " modified='$now' WHERE username='$username'";
    $result = $this->db->query( $q ); 
    if( DB::isError($result) ) 
      $this->sql_error( $q, $result );
  }



  function get_person_list( $n=10 ){
    $q = "SELECT * FROM fossfa_people WHERE publish=1 AND LENGTH(name)>1 ".
      " ORDER by entered DESC LIMIT $n";
    $result = $this->db->query( $q ); 
    if( DB::isError($result) ) 
      $this->sql_error( $q, $result );
    $ret = Array();
    while( $res = $result->fetchRow(DB_FETCHMODE_ASSOC) ){ 
      $ret[] = $res; 
    } 
    return $ret;
  }


  function update_image( $username, $imgdata, $imgtype, $imgsize, $imgname ){
    // TODO: scale image to max 200 width

    $result = $this->db->query( "SELECT * FROM fossfa_people WHERE username='$username'" );
    if( $result->numRows() < 1 ){
      return false; // no such user page yet
    }

    $imgdata = addslashes($imgdata);
    $imgname = addslashes($imgname);

    $q = "UPDATE fossfa_people SET ".
      " imgdata='$imgdata', imgsize='$imgsize', imgtype='$imgtype', imgname='$imgname' ".
      " WHERE username='$username'";
    $result = $this->db->query( $q ); 
    if( DB::isError($result) ) 
      $this->sql_error( $q, $result );
  }
    




  function search( $term, $db="people" ){

    if( $db != "people" ){
      $q = "SELECT * FROM fossfa_project ".
	" WHERE visible=1 ".
	"   AND ".
	"  ( name LIKE '%$term%' OR ".
	"    shortdesc LIKE '%$term%' OR ".
	"    body  LIKE '%$term%' ) ".
	" ORDER by modified DESC";
      
      // print "$q<p>";
      
      $result = $this->db->query( $q ); 
      if( DB::isError($result) ) 
	$this->sql_error( $q, $result );
      
      $ret = Array();
      while( $res = $result->fetchRow(DB_FETCHMODE_ASSOC) ){ 
	$data = $res;
	$tmp["link"] = "fossfa-db.php?view=project&id=".$data["projectId"];
	$tmp["text"] = $data["name"];
	$tmp["desc"] = $data["shortdesc"];

	$ret[] = $tmp;
      } 
      return $ret;

    } else { 

      $q = "SELECT * FROM fossfa_people ".
	" WHERE publish>0 ".
	"   AND ".
	"  ( name LIKE '%$term%' OR ".
	"    username LIKE '%$term%' OR ".
	"    email LIKE '%$term%' OR ".
	"    based LIKE '%$term%' OR ".
	"    interests LIKE '%$term%' OR ".
	"    body  LIKE '%$term%' ) ".
	" ORDER by modified DESC";
      
      // print "$q<p>";
      
      $result = $this->db->query( $q ); 
      if( DB::isError($result) ) 
	$this->sql_error( $q, $result );
      
      $ret = Array();
      while( $res = $result->fetchRow(DB_FETCHMODE_ASSOC) ){ 
	$data = $res;
	$tmp["link"] = "fossfa-db.php?view=person&username=".$data["username"];
	if( strlen($data["name"])>0 ){
	  $tmp["text"] = $data["name"];
	} else {
	  $tmp["text"] = $data["username"];
	}
	$tmp["desc"] = "Based in ".$data["based"];

	$ret[] = $tmp;
      } 
      return $ret;
    }
  }

}

?>
